ParticleClear:
	 mov	[ParticleCount], word 0

ParticleCreate:
        ;CX     particle x
        ;DX     particle y
        ;AH     particle colour
        ;AL     particle speed
        ;BX     particle direction
        ;SI     particle life (only one byte!)
        push    si
        push    dx
        push    cx
        push    ax
        push    bx


        mov     ax, [ParticleCount]
        mov     dx, 10d
        mul     dx
        mov     bx, ax
        add     bx, ParticleBuffer
        pop     ax
        mov     [bx], ax
        add     bx, 2
        pop     ax
        mov     [bx], ax
        add     bx, 2
        pop     cx
        pop     dx
        mov     [bx], cx
        add     bx, 2
        mov     [bx], dx
        add     bx, 2
        pop     ax
        mov     [bx], byte al
        inc     bx
        mov     [bx], byte 0FFh
        mov     dx, [ParticleCount]
        inc     dx
        mov     [ParticleCount], dx


ret

StepPause:
        push    ax
        mov     al, 20h
        out     20h, al
        pop     ax  
iret


StepEvent:
        push    ax
        push    bx
        push    cx
        push    dx
        push    si
        push    es
        ;;;;;;;;;;;;;;;;;;;;

        mov     ax, 0a000h
        mov     es, ax
	
        mov     ax, [ParticleCount]
        cmp     ax, 0
        je      ParticleDrawLoopEnd
        mov     dx, 10d
        mul     dx
        add     ax, ParticleBuffer
        mov     bx, ax
;        cmp     [bx], byte 0ffh
;        jne     ParticleDrawLoop

        ParticleDrawLoop:
                dec	bx
		mov     dl, [bx]
                cmp     dl, 0FFh
                jne     ParticleDrawLoopEnd
                dec     bx

                mov     dh, [bx]
                cmp     dh, 0                   ;Check particle's life
                je      ParticleDelete ;ParticleDelete

                dec     dh                      ;Decrease life
                mov     [bx], dh

                sub     bx, 2
                mov     dx, [bx]
                push    dx
                sub     bx, 2
                mov     cx, [bx]
                push    cx
                sub     bx, 2
                mov     ax, dx
                mul     word [Line]
                add     ax, cx
		mov	dx, ax
                mov     ax, [bx]
                sub     bx, 2
                mov     si, dx
                mov     [es:si], byte 0 ;, ah
		mov		[Colour], ah

		mov    dx, ax
		xor	dh, dh
		push    dx
		mov [ParticleSpeed], dl
		mov    ax, [bx]
		call    Cos
		mov    si, ax
		and    si, 10000000_00000000b
		and    ax, 01111111_11111111b
		mul    dx
		div    word [Denominator]
		pop    dx
		pop	cx
		cmp    si, 10000000_00000000b
		je    CosNegative
		
		add    cx, ax 
		jmp    CosEnd
		CosNegative:
		sub    cx, ax
		CosEnd:
		mov    si, bx
		add    si, 4
		mov    [si], cx
		mov		[NewX], cx
		
		;pop	dx
		
		xor	ch, ch
		mov cl, [ParticleSpeed]
		mov    ax, [bx]
		call    Sin
		mov    si, ax
		and    si, 10000000_00000000b
		and    ax, 01111111_11111111b
		mul    cx
		div    word [Denominator]
		pop    dx

		cmp    si, 10000000_00000000b
		je    SinNegative
		add    dx, ax 
		jmp    SinEnd
		SinNegative:
		sub    dx, ax
		SinEnd:
		mov    si, bx
		add    si, 6
		mov    [si], dx
		
		mov     ax, dx
                mul     word [Line]
		mov		cx, [NewX]
                add     ax, cx
		mov		si, ax
		mov		ah, [Colour]
		mov		[es:si], ah
		
		jmp		ParticleNext
		
		ParticleDelete:
		; mov		si, bx
		; add		si, 2
		; sub		bx, 8
		; push	bx
		; mov     	ax, [ParticleCount]
		; mov    	 dx, 10d
		; mul     	dx
		; add     	ax, ParticleBuffer
		; mov		dx, ax
		
		; ParticleDeleteLoop:
			; mov		al, [si]
			; mov		[bx], al
			; inc		bx
			; inc		si
			; cmp		bx, dx
		; jne		ParticleDeleteLoop
		
		; mov		dx, [ParticleCount]
		; dec		dx
		; mov		[ParticleCount], dx
		
		; pop		bx
		
		sub     bx, 2
                mov     dx, [bx]
                sub     bx, 2
                mov     cx, [bx]
                mov     ax, dx
                mul     word [Line]
                add     ax, cx
		mov	dx, ax
                mov     si, dx
                mov     [es:si], byte 0
		
		sub		bx, 4
		ParticleNext:
                cmp     bx, ParticleBuffer
        jne     ParticleDrawLoop

        ParticleDrawLoopEnd:
        ;;;;;;;;;;;;;;;;;;;;
        mov     al, 20h
        out     20h, al

        pop     es
        pop     si
        pop     dx
        pop     cx
        pop     bx
        pop     ax
iret


Gravity 		equ 200
ParticleSpeed    db 0
Line    		dw 320d
Denominator	dw 1000d

NewX		dw 0
Colour		db 0

ParticleCount	dw 0
